{ Programname has to be a string }
program 'Demo of Fargo Pascal';
uses tios,flib,gray4lib;


import macros;


var sprdemo: sprites = 'DEMOSPR';
    seted: word;
    current_p: pointer;
    ax1,ax2: integer;
    lcd_pointer,gray_pointer: pointer;
    { Strings have to be initialised, all other types can't be initialised }
    str1: string = 'Fargo Pascal V0.8.13';
    str2: string = 'by MXM Projects';
    demo_1: string = 'Demonstration of arrays';
    demo_2: string = 'Demonstration of pointers';
    demo_3: string = 'Creating a line with pointers';
    demo_4: string = 'Demonstration of if';
    demo_5: string = 'Demonstration of sprites';
    demo_6: string = 'Demonstration of while';
    demo_7: string = 'Demonstration of readln';
    if_1: string = 'If instruction passed';
    { Output is a buffer for the sprintf function ( Space: 35 chars ) }
    output: string[35];
    format: string = 'demo_array[%d] = %d';
    format_2: string = 'Pointer = $%lx';
    demo_array: array[0..10,0..1] of integer;
    { EXTERNAL: Includes an extern file }
    extern_file: external = 'EXAMPLE.EXF';

    demo_record: array[5] of record
      i: byte;
      name: array[0..11] of char;
    end;


    str_readed: string[35];
    r: real;

procedure grayclear();
begin
{
  Demonstration of inline assembler
  Compiler probably optimize this!
  e.g move.w #0,d0 will be replaced by clr.w d0
}
asm
 move.l gray4lib::plane0,a0
 move.l gray4lib::plane1,a1
 move.w #959,d0
_sillyclearloop:
 clr.l (a1)+
 clr.l (a0)+
 dbra.w d0,_sillyclearloop
end;
{ The same in Pascal / only when local variables are supported!
  procedure grayclear();
  var mp1,mp2: pointer;
      i: word;
  begin
   mp1:=gray4lib::plane0;
   mp2:=gray4lib::plane1
   for i:=0 to 959 do begin

    Memoryreferences are longs ( standard )

    mp1^:=0;
    mp2^:=0;
    inc(mp1,4);
    inc(mp2,4);
   end;
  end;
}
end;

begin
 { Notice: Rackets are needed, but you can write it as you want! }
 flib::ZaP_scREen();
 setfont(2);
 tios::DrawStrXY(1,0,str1,4);
 tios::DrawStrXY(1,15,str2,4);

 tios::DrawStrXY(40,50,'Demonstration',4);
 setfont(1);
 tios::DrawStrXY(1,30,'http://members.vol.at/schoenach',4);
 waitforakey();

 tios::DrawStrXY(1,1,demo_1,4);

 { Demonstration of arrays }

 setfont(0);

 for ax1:=0 to 10 do begin
  demo_array[ax1,0]:=ax1;

  tios::sprintf(output,format,ax1,demo_array[ax1,0]);

  tios::DrawStrXY(1,ax1*7+20,output,4);
 end;

 waitforakey();
 setfont(1);
 tios::DrawStrXY(1,1,demo_2,4);

 { Getting the pointers to the memory }
 lcd_pointer:=tios::main_lcd;

 tios::sprintf(output,format_2,lcd_pointer);
 tios::DrawStrXY(1,70,output,4);

 tios::DrawStrXY(1,30,demo_3,4);

 {
   We want to create the line in the screenline 50 and per screenline there are
   30 bytes.
 }
 inc(lcd_pointer,30*49);

 { 30 Bytes per Line -> fastest possibility is 15 Words }
 for ax1:=0 to 14 do begin
   lcd_pointer^:=$FFFF;

   inc(lcd_pointer,2);
 end;
 waitforakey();

 tios::DrawStrXY(1,1,demo_4,4);

 seted:=0;
 for ax1:=0 to 50 do begin
  setfont(2);
  tios::DrawStrXY(ax1,20,str1,4);
  tios::DrawStrXY(ax1,35,str2,4);

  if (ax1>= 10) and (seted =0) then begin
   setfont(1);
   tios::DrawStrXY(1,60,if_1,4);
   flib::idle_loop();
   seted:=1;
  end;
 end;

 waitforakey();

 { Demonstration of Sprites }

 ax1:=gray4lib::on();
 if (ax1<>0) then begin
  grayclear();

  tios::DrawStrXY(1,1,demo_5,4);

 for ax2:=0 to 4 do
  for ax1:=0 to 14 do
   { Create a little field }
   paslib::put_sprite_move(ax1*16,40+ax2*16,flib::random(3)+1,sprdemo);
  waitforakey();
  gray4lib::off();
 end else begin
  tios::drawstrxy(1,1,'Can not activate Gray4Lib!',4);
  waitforakey();
 end;
 {
  demo_record.i  equals demo_record[0].i!
 }
 demo_record.i:=1;

 tios::drawstrxy(1,1,demo_6,4);
 setfont(1);
 seted:=0;
 while (seted<>34) do begin
  seted:=flib::random(100);
  tios::sprintf(output,'seted = %d',seted);
  tios::drawstrxy(1,25,output,4);
 end;
 waitforakey();
 setfont(2);

 tios::drawstrxy(1,1,demo_7,4);

 setfont(1);

 current_p:=@demo_record.name;
 readln(current_p,1,50,10);

 flib::zap_screen();

 setfont(2);
 tios::drawstrxy(1,1,'Demonstration of floats',4);

 r:=1.0;
 r:=r*2.0e0;

 { FTOA is a procedure, defined in MACROS.FPM }
 { ftoa(r,output); -> Doesn't work right

 setfont(2);
 tios::drawstrxy(1,1,output,4);}

 waitforakey();
 { End of the program }
end;